//EBS_45 - Funes com vetores pearson
#include <iostream>
#include <conio.h>
#include <cmath>
using namespace std;

void lanca_vetor(float vet[], int tam);
void exibir_vetor(float vet[], int tam);
float media_vetor(float vet[], int tam);
float pearson(float vet1[], float vet2[], int tam, float MDx, float MDy);

int main()
{
	int n;
	cout << "*** Calculo da Media com Vetores e Funcoes ***";
	cout << endl << endl;
	cout << "Digite o tamanho do vetor = ";
	cin >> n;
	float x1[n], x2[n], md1, md2, dpearson;
	cout << endl << endl;
	cout << "*** Lancar dados no Vetor 1 ***";
    cout << endl;
	lanca_vetor(x1, n);
	cout << endl << endl;
	cout << "*** Lancar dados no Vetor 2 ***";
    cout << endl;
	lanca_vetor(x2, n);
	cout << endl << endl;
	cout << "*** Dados lancados no Vetor 1 ***";
    cout << endl;
	exibir_vetor(x1,n);
	cout << endl << endl;
	cout << "*** Dados lancados no Vetor 2 ***";
    cout << endl;
	exibir_vetor(x2,n);
    md1 = media_vetor(x1, n);
    md2 = media_vetor(x2, n);
    dpearson = pearson(x1, x2, n, md1, md2);
	cout << endl << endl;
    cout << "Pearson = " << dpearson;
	getch();
}

void lanca_vetor(float vet[], int tam)
{
	for (int i=0; i<tam;i++)
	{
		cout << "Digite o " << i+1 << "o. valor = ";
		cin >> vet[i];
	}
}

void exibir_vetor(float vet[], int tam)
{
	for (int i=0; i<tam;i++)
	{
		cout << i+1 << "o. valor = " << vet[i];
		cout << endl;
	}
}

float media_vetor(float vet[], int tam)
{
	float xx=0.00;
	for (int i=0; i<tam;i++)
	{
		xx = xx + vet[i];
	}
	xx = xx / tam;
	return (xx);
}

float pearson(float vet1[], float vet2[], int tam, float MDx, float MDy)
{
	float xxy=0.00, xx=0.00, yy=0.00, xp;
	for (int i=0; i<tam;i++)
	{
		xx = xx + pow((vet1[i]-MDx),2);
		yy = yy + pow((vet2[i]-MDy),2);
        xxy = xxy + ((vet1[i]-MDx)*(vet2[i]-MDy));
	}
	xp = (xxy / (sqrt(xx)*sqrt(yy)));
	return (xp);
}

